import { Component, OnInit, Inject } from '@angular/core';

import { WINDOW } from './window.component';



@Component({
  selector: 'app-char3-d',
  templateUrl: './char3-d.component.html',
  styleUrls: ['./char3-d.component.css']
})
export class Char3DComponent {
  constructor(
    @Inject(WINDOW) private window: Window,
  ) { }
  ngOnInit(): void {
    const my_window = window as any;
    const that = this;
    my_window.vh_audioEnded = () => {
      if (my_window.initialClick) {
        my_window.initialClick = false;
        return;
      }
      setTimeout(() => {
        that.updateMessage("Received 'vh_audioEnded' event \n");
        my_window.currentStep += 1;
        this.conversation();
      }, 50);
    };
    my_window.vh_sceneLoaded = function () {
      my_window.setStatus(1, 0, 0, 1);
      that.updateMessage("Received 'vh_sceneLoaded' event \n   calling: 'setStatus(1, 0, 0, 1)' \n");
    }



    my_window.vh_audioProgress = function (percentPlayed) {
      that.updateMessage("Received 'vh_audioProgress' at " + percentPlayed + "% \n");
    }

    my_window.vh_audioStarted = function () {
      that.updateMessage("Received 'vh_audioStarted' event \n");
    }

    my_window.vh_saySilent = function () {
      that.updateMessage("Received 'vh_saySilent' event \n");
    }
  }



  sayAudioFn(sayAudioExample) {

    globalThis.sayAudio('sayAudioExample');
  }
  sayTextFn(text, ip1, ip2, ip3) {
    console.log(text, ip1, ip2, ip3);
    globalThis.sayText(text, ip1, ip2, ip3);
  }
  startConv() {
    this.updateMessage("start event received.\n");
    globalThis.initialClick = true;
    //transform the array into object form 
    globalThis.portalArrayObjects = globalThis.portalArray.reduce((acc, item) => {
      const key = Object.keys(item)[0];
      acc[key] = item[key];
      return acc;
    }, {});


    globalThis.currentStep = 1;
    this.conversation();
    setTimeout(() => {
      globalThis.initialClick = false;
    }, 2000);


  }

  conversation() {

    var currentStep = globalThis.currentStep;
    var a = globalThis.portalArrayObjects['abc'];
    var b = globalThis.portalArrayObjects['xyz'];

    switch (currentStep) {
      case 1:
        globalThis.selectPortal(b);
        globalThis.setGaze(270, 5, 100);
        globalThis.selectPortal(a);
        globalThis.sayText('Welcome to the SitePal conversation example page', 2, 1, 3);
        break
      case 2:
        globalThis.selectPortal(a);
        globalThis.setGaze(90, 5, 100);
        globalThis.selectPortal(b);
        globalThis.sayText('When multiple Scenes are embedded on the same page, only one of them accepts API calls at any given time.', 1, 1, 3);
        break
      case 3:
        globalThis.selectPortal(b);
        globalThis.setGaze(270, 5, 100);
        globalThis.selectPortal(a);
        globalThis.sayText('The "Select Portal" call can be used to select the Scene that accepts API calls.', 2, 1, 3);
        break
      case 4:
        globalThis.selectPortal(a);
        globalThis.setGaze(90, 5, 100);
        globalThis.selectPortal(b);
        globalThis.sayText('To use this call, you must collect the Scene reference when the embedded Scene is loaded – by assigning the values returned by the “Embed” function', 1, 1, 3);
        break;
    }
  }

  vh_audioEnded() {
    console.log('audio ended')
  }

  vh_talkEnded() {
    if (globalThis.initialClick) {
      globalThis.initialClick = false;
      return;
    }
    setTimeout(() => {
      globalThis.currentStep += 1;
      this.conversation();
    }, 50);
  }
  embed: any[] = [3432155, 300, 400, "''", 1, 1, 2695693, 0, 1, 1, "'85c776a6ec18b1e8cafedc94fdd0f31b'", 0];
  embed2: any[] = [3432155, 300, 400, "''", 1, 1, 2695938, 0, 1, 1, "'83e9cf749c828c00f267098eefd1eca5'", 0];
  spn: string = 'xyz';
  spn2: string = 'abc';

  message: string = '';

  updateMessage(eventType: string) {
    this.message += eventType;
  }
}
